#! /usr/bin/env python
# -*- coding: Latin-1 -*-
# author: Arnaud Chapon

from optparse import OptionParser
import math
import os, sys

debug = 0

###

parser = OptionParser()
parser.add_option("-i", dest="inf", help ="in_file")
(options, args) = parser.parse_args()

if len(sys.argv) != 3:
    if debug:
        print "nb_arg = ", len(sys.argv) 
    parser.error("usage: python stat.py -i IN_FILE")

in_file  = options.inf

###


def init ( in_file_ ):
    inf = open ( in_file_,  'r' )
    sample=[]
    while 1:
        line = inf.readline()
        word = []
        if line == '':
            break
        if line[0] != '#':
            word = line.split()
        counter = 0
        while counter < len ( word ):
            sample.append ( float ( word [ counter ] ) )
            counter += 1
    return sample


def stat_moyenne ( sample_ ) :
    n   = len( sample_ )
    moy = sum( sample_ ) / n
    return moy

def stat_variance ( sample_ ) :
    n  = len ( sample_ )
    mq = stat_moyenne ( sample_ )**2
    s  = sum ( [ x**2 for x in sample_ ] )
    var = s / n - mq
    return var

def stat_ecart_type ( sample_ ) :
    var = stat_variance ( sample_ )
    sig = math.sqrt ( var )
    return sig


###

echantillon = init ( in_file )
moy=stat_moyenne( echantillon )
var=stat_variance( echantillon )
sig=stat_ecart_type( echantillon )

print "valeurs (" + str(len(echantillon)) + ") = " + str(echantillon) + '\n'
print "moyenne    : " + str(moy) + '\n'
print "variance   : " + str(var) + '\n'
print "ecart-type : " + str(sig) + '\n'
